//Stopwatch is meant to track the passage of time, just like a real life stopwatch
Stopwatch
	var
		stored_time
		tmp/running_start_time

	Write(var/savefile/s)
		if(isRunning()) stored_time = getElapsedTime()
		..()
		setStartTime()

	proc
		Start()
			setStartTime()
		Stop()
			running_start_time = null
		Reset()
			stored_time = 0
			setStartTime()

		isRunning()
			return running_start_time != null
		setStartTime()
			running_start_time = world.time
		getElapsedTime()
			return isRunning() ? stored_time + world.time - running_start_time : stored_time

//Playtime Stopwatch is meant to track a player's lifetime playtime
//This gets utilized every time a player loads their progress or starts a new character
//Uses world.timeofday instead of world.time like its parent
	Playtime
		setStartTime() //Gotta overload this to use world.timeofday
			running_start_time = world.timeofday
		getElapsedTime() //Gotta overload this to use world.timeofday
			return isRunning() ? stored_time + world.timeofday - running_start_time : stored_time

//Daily Playtime Stopwatch is meant to track a player's playtime within a single 24 hour period of time
//This gets utilized by the Daily Rewarder
		Daily
			var
				last_known_day_value

			New()
				..()
				if(isNewDay())
					src.Reset()
			Start()
				setLastKnownDayValue()
				..()
			Reset()
				setLastKnownDayValue()
				..()

			proc
				isNewDay()
					return last_known_day_value < getCurrentDayValue()
				setLastKnownDayValue()
					last_known_day_value = getCurrentDayValue()
				getCurrentDayValue()
					return round(world.realtime/864000)